//+------------------------------------------------------------------+
//|                         Fx Snipper's Ergodic CCI Trigger + alert |
//+------------------------------------------------------------------+
#property  copyright "mladen"
#property  link      "mladenfx@gmail.com"

#property  indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Green
#property indicator_color2  Green
#property indicator_color3  Red
#property indicator_color4  Red
#property indicator_color5  DimGray
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2

//
//
//
//
//

extern int  pq            =  2;
extern int  pr            = 10;
extern int  ps            =  5;
extern int  trigger       =  3;
extern bool alertsOn      = false;
extern bool alertsMessage = true;
extern bool alertsSound   = false;
extern bool alertsEmail   = false;


double buffUa[];
double buffUb[];
double buffDa[];
double buffDb[];
double ErgoCCI[];
double MainCCI[];
double buffer[][8];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,buffUa);  SetIndexLabel(0,"Ergodic CCI - up");   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffUb);  SetIndexLabel(1,"Ergodic CCI - down"); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffDa);  SetIndexLabel(2,"Ergodic CCI - down"); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffDb);  SetIndexLabel(3,"Ergodic CCI - up");   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ErgoCCI); SetIndexLabel(4,"Ergodic CCI");
   SetIndexBuffer(5,MainCCI); SetIndexLabel(5,"Trigger Line");
   return(0);
}

//
//
//
//
//

#define mtm    0
#define absmtm 1
#define var1   2
#define var2   3
#define var2a  4
#define var2b  5
#define var2c  6
#define var2d  7

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (ArrayRange(buffer,0) != Bars) ArrayResize(buffer,Bars);
 

   //
   //
   //
   //
   //
   

   double alphaPq = 2.0/(1.0+pq);
   double alphaPr = 2.0/(1.0+pr);
   double alphaPs = 2.0/(1.0+ps);
   double alphaTrigger = 2.0/(1.0+trigger);
   
   for(i=limit,r=Bars-limit-1; i >=0; i--,r++) 
   {
      buffer[r][mtm]    = Close[i]-Close[i+1];
      buffer[r][absmtm] = MathAbs(buffer[r][mtm]);
      buffer[r][var1]   = buffer[r-1][var1]  + alphaPq*(buffer[r][mtm]   -buffer[r-1][var1]);
      buffer[r][var2]   = buffer[r-1][var2]  + alphaPr*(buffer[r][var1]  -buffer[r-1][var2]);
      buffer[r][var2a]  = buffer[r-1][var2a] + alphaPq*(buffer[r][absmtm]-buffer[r-1][var2a]);
      buffer[r][var2b]  = buffer[r-1][var2b] + alphaPr*(buffer[r][var2a] -buffer[r-1][var2b]);
      buffer[r][var2c]  = buffer[r-1][var2c] + alphaPs*(buffer[r][var2]  -buffer[r-1][var2c]);
      buffer[r][var2d]  = buffer[r-1][var2d] + alphaPs*(buffer[r][var2b] -buffer[r-1][var2d]);
      if (buffer[r][var2d]!=0)
            ErgoCCI[i] = (500*buffer[r][var2c]/buffer[r][var2d]);
      else  ErgoCCI[i] = 0;
            MainCCI[i] = MainCCI[i+1] + alphaTrigger*(ErgoCCI[i]-MainCCI[i+1]);

      //
      //
      //
      //
      //
      
      buffUa[i] = EMPTY_VALUE;
      buffUb[i] = EMPTY_VALUE;
      buffDa[i] = EMPTY_VALUE;
      buffDb[i] = EMPTY_VALUE;
      if (ErgoCCI[i]>0)
      {
         if (ErgoCCI[i]>ErgoCCI[i+1])
               buffUa[i] = ErgoCCI[i];
         else  buffUb[i] = ErgoCCI[i];
      }
      if (ErgoCCI[i]<0)
      {
         if (ErgoCCI[i]<MainCCI[i+1])
               buffDa[i] = MainCCI[i];
         else  buffDb[i] = MainCCI[i];
      }    
   }
   if (alertsOn)
      {
       if(MainCCI[1] <= ErgoCCI[1] && MainCCI[0] > ErgoCCI[0]) doAlert("short");
       if(MainCCI[1] >= ErgoCCI[1] && MainCCI[0] < ErgoCCI[0]) doAlert("long");
      }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ergodic ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ergodic crossing"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}